-- actual wowkedex log.
local HeaderBackdrop =
{
    bgFile = "",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = false, tileSize = 16, edgeSize = 16,
    insets = { left = 3, right = 3, top = 5, bottom = 3 }
}

local TooltipBackdrop =
{
    bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = false, tileSize = 16, edgeSize = 16,
    insets = { left = 3, right = 3, top = 5, bottom = 3 }
}

local builtState = false;
local scrollFrameRef = nil;
local wowkedexFrames = {}
local frameHolder = nil;
local childscroll = nil;
local column = 0
local row = 0
local spaceR = 100;
local spaceC = -100;
local offsetX = 15;
local offsetY = -20;
local skillPanels = {}
local WowkemonSkillToolTip = CreateFrame("Frame","WowkemonSkillTooltip",UIParent)
WowkemonSkillToolTip:Hide()
WowkemonSkillToolTip:SetBackdrop(TooltipBackdrop)
WowkemonSkillToolTip:SetBackdropColor(0,0,0,1)
WowkemonSkillToolTip:SetSize(250,35)
WowkemonSkillToolTip:SetFrameLevel(7)
WowkemonSkillToolTip.Text = WowkemonSkillToolTip:CreateFontString(nil,"OVERLAY","GameFontNormal")
WowkemonSkillToolTip.Text:SetNonSpaceWrap(true)
WowkemonSkillToolTip.Text:SetWidth(WowkemonSkillToolTip:GetWidth()-15)
WowkemonSkillToolTip.Text:SetPoint("TOPLEFT",5,-5)
WowkemonSkillToolTip:SetScript("OnUpdate",
  function()
    local mouseFocus=GetMouseFocus()
    local x, y = GetCursorPosition();
    local scale = WowkemonSkillToolTip:GetEffectiveScale()
    WowkemonSkillToolTip:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", (x/scale + 20), (y/scale - 20))
  end)

function makeScrollerFrame(inFrame)
if builtState == false then
frameHolder = inFrame -- or CreateFrame("Frame", nil, inFrame); -- re-size this to whatever size you wish your ScrollFrame to be, at this point


--if builtState == false then
--  builtState = true
frameHolder:SetHeight(WowkedexScreenWindowFrame:GetHeight()-50);
frameHolder:SetWidth(WowkedexScreenWindowFrame:GetWidth()-10);
frameHolder:SetPoint("BOTTOMLEFT",0,25)
frameHolder.scrollframe = frameHolder.scrollframe or CreateFrame("ScrollFrame", "ANewScrollFrame", frameHolder, "UIPanelScrollFrameTemplate");
frameHolder.scrollchild = frameHolder.scrollchild or CreateFrame("Frame"); -- not sure what happens if you do, but to be safe, don't parent this yet (or do anything with it)
-- define the scrollframe's objects/elementss
local scrollbarName = frameHolder.scrollframe:GetName()
frameHolder.scrollbar = _G[scrollbarName.."ScrollBar"];
frameHolder.scrollupbutton = _G[scrollbarName.."ScrollBarScrollUpButton"];
frameHolder.scrolldownbutton = _G[scrollbarName.."ScrollBarScrollDownButton"];
-- all of these objects will need to be re-anchored (if not, they appear outside the frame and about 30 pixels too high)
frameHolder.scrollupbutton:ClearAllPoints();
frameHolder.scrollupbutton:SetPoint("TOPRIGHT", frameHolder.scrollframe, "TOPRIGHT", -2, -2);
frameHolder.scrolldownbutton:ClearAllPoints();
frameHolder.scrolldownbutton:SetPoint("BOTTOMRIGHT", frameHolder.scrollframe, "BOTTOMRIGHT", -2, 2);
frameHolder.scrollbar:ClearAllPoints();
frameHolder.scrollbar:SetPoint("TOP", frameHolder.scrollupbutton, "BOTTOM", 0, -2);
frameHolder.scrollbar:SetPoint("BOTTOM", frameHolder.scrolldownbutton, "TOP", 0, 2);
-- now officially set the scrollchild as your Scroll Frame's scrollchild (this also parents frameHolder.scrollchild to frameHolder.scrollframe)
-- IT IS IMPORTANT TO ENSURE THAT YOU SET THE SCROLLCHILD'S SIZE AFTER REGISTERING IT AS A SCROLLCHILD:
frameHolder.scrollframe:SetScrollChild(frameHolder.scrollchild);
-- set frameHolder.scrollframe points to the first frame that you created (in this case, frameHolder)
frameHolder.scrollframe:SetAllPoints(frameHolder);
-- now that SetScrollChild has been defined, you are safe to define your scrollchild's size. Would make sense to make it's height > scrollframe's height,
-- otherwise there's no point having a scrollframe!
-- note: you may need to define your scrollchild's height later on by calculating the combined height of the content that the scrollchild's child holds.
-- (see the bit below about showing content).
frameHolder.scrollchild:SetSize(frameHolder.scrollframe:GetWidth(), ( frameHolder.scrollframe:GetHeight() ));
-- THE SCROLLFRAME IS COMPLETE AT THIS POINT.  THE CODE BELOW DEMONSTRATES HOW TO SHOW DATA ON IT.
-- you need yet another frame which will be used to parent your widgets etc to.  This is the frame which will actually be seen within the Scroll Frame
-- It is parented to the scrollchild.  I like to think of scrollchild as a sort of 'pin-board' that you can 'pin' a piece of paper to (or take it back off)
frameHolder.childFrame = frameHolder.childFrame or CreateFrame("Frame", nil, frameHolder.scrollchild);
frameHolder.childFrame:SetAllPoints(frameHolder.scrollchild);
--end
local wowkemonTexturePath
local wowkemonModelID
local wowkemonModelCamOffset
local exists = false;


for w,k in pairs(WowkemonPlayerData["Wowkedex"]) do -- Complex checks for model..
  exists = false;
  local isRare = false
  local index = 0
  local skills
  for r,i in pairs(wowkemonUniqueSpawnLocs) do
     for p in pairs(i) do
    if i[p][1] == w then
      wowkemonTexturePath = i[p][2];
      wowkemonModelID = i[p][6] or 5868;
      wowkemonModelCamOffset = i[p][7] or {0,0,0};
      index = r
      skills = i[p][4]
      isRare = true;
      break
      end
    end
    end
    if isRare ~= true then
  for e in pairs(Wowkemons) do
    if Wowkemons[e][1] == w then
      wowkemonTexturePath = Wowkemons[e][2]
      wowkemonModelID = Wowkemons[e][6] or 5868;
      wowkemonModelCamOffset = Wowkemons[e][7] or {0,0,0}
      skills = Wowkemons[e][4]
      break
    end
  end
  end
  if row == 3 then
    column = column + 1
    row = 0
  end
  if exists == false then
    local curID = wowkemonModelID
    local frame = CreateFrame("Frame","wowkedexEntry"..w,frameHolder.scrollchild)
    frame:SetPoint("TOPLEFT",frameHolder.scrollchild,"TOPLEFT",(row*spaceR)+ offsetX,(column*spaceC)+offsetY)
    frame:SetSize(80,80)
    frame:SetBackdrop(HeaderBackdrop)
    frame.model = CreateFrame("DressUpModel","wowkemonModelFrame",frame);
  --  frame.model:SetModel(5828)
    frame.model:SetSize(80,80)--(172,300)
  --  frame.model:SetScale(0.25)
  --  frame.model:SetAllPoints()
  --  frame.model:SetLight(1)
--  frame.model:SetModelScale(0.25)
--  frame.model:SetModel("creature/kobold/kobold.m2") --("creature/tiger/tiger.m2")
frame.model:SetDisplayInfo(wowkemonModelID)
frame.model:SetCreature(wowkemonModelID)
frame.model:SetPosition(wowkemonModelCamOffset[1],wowkemonModelCamOffset[2],wowkemonModelCamOffset[3])
 frame.model:SetAllPoints()
 --frame.model:TryOn(6802)
  --  frame.model:SetDisplayInfo(728)
    frame.model:SetPoint("CENTER")
    local btn = CreateFrame("Button","wowkedexBtn"..w,frame)
    frame.text = frame:CreateFontString(nil,"OVERLAY","GameFontNormal")
    frame.text:SetText(w)
    frame.text:SetPoint("TOP",frame,"TOP",0,10)
  --  frame.texture = frame:CreateTexture(nil,"OVERLAY");
  --  frame.texture:SetTexture(wowkemonTexturePath)
  --  frame.texture:SetSize(frame:GetSize())
  --  frame.texture:SetPoint("CENTER",frame,"CENTER")
    btn:SetSize(frame:GetSize())
    btn:SetPoint("CENTER","wowkedexEntry"..w,"CENTER")
    btn:SetScript("OnClick", function() makeWowkemonDetailFrame(w,inFrame,curID,skills) end)
    row = row + 1;
    table.insert(wowkedexFrames,w);
  end
end
builtState = true;
frameHolder.scrollchild:SetSize(frameHolder.scrollframe:GetWidth(), ( frameHolder.scrollframe:GetHeight() * math.max((column/2),1) ) )

frameHolder = frameHolder;
else
end
frameHolder:Show()
scrollFrameRef = frameHolder;
return frameHolder
end


function makeWowkemonDetailFrame(dataKey,inFrame,modelID,skills) -- Load the wowkemon detail panel
scrollFrameRef:Hide();
local textContent = "|Cff3131ce"..dataKey.."|r\nTotal Captures: "..WowkemonPlayerData["Wowkedex"][dataKey][2]..
                  "\nHighest level: "..WowkemonPlayerData["Wowkedex"][dataKey][3]..
                  "\nTotal Candy: "..WowkemonPlayerData["Wowkedex"][dataKey][1]..
                  "\n\n|Cff3131ceStats|r"..
                  "\nStamina: "..WowkemonPlayerData["Wowkedex"][dataKey]["Stats"]["Stamina"]..
                  "\nHP: "..WowkemonPlayerData["Wowkedex"][dataKey]["Stats"]["Stamina"] * 20
wowkemonPanel:Show()
wowkemonPanel:SetSize(wowkedexPanel:GetSize());
wowkemonPanel:SetPoint("TOPLEFT",WowkedexScreenWindowFrame,"TOPLEFT")
wowkemonPanel.textContent:SetText(textContent)
wowkemonPanel.textContent:SetPoint("TOPLEFT",wowkemonPanel,"TOPLEFT",20,-15)
wowkemonPanel.textContent:SetSize(wowkedexPanel:GetSize())
if wowkemonPanel.render3d == nil then
  wowkemonPanel.SetPvpWowkemon = CreateFrame("Button","SetBattleWowkemon",wowkemonPanel,"UIPanelButtonTemplate")
  wowkemonPanel.SetPvpWowkemon:SetText("Set PVP")
  wowkemonPanel.SetPvpWowkemon:SetPoint("TOPRIGHT",wowkemonPanel,"TOPRIGHT",0,-200)
  wowkemonPanel.render3d = CreateFrame("DressUpModel","wowkemonpanelrender3d",wowkemonPanel,"ModelWithControlsTemplate")
  --wowkemonPanel.render3d:SetBackdrop(HeaderBackdrop)
  wowkemonPanel.StaminaUpgrade = CreateFrame("Button","WowkemonPanelStaminaUpgrade",wowkemonPanel)
  wowkemonPanel.StaminaUpgrade:SetSize(30,30)
  wowkemonPanel.StaminaUpgrade:SetBackdrop(HeaderBackdrop)
  wowkemonPanel.StaminaUpgrade:SetPoint("CENTER",0,0,wowkemonPanel.textContent,"BOTTOM",0,0)
  wowkemonPanel.StaminaUpgrade.texture = wowkemonPanel.StaminaUpgrade:CreateTexture(nil,"OVERLAY");
  wowkemonPanel.StaminaUpgrade.texture:SetTexture("Interface\\Icons\\spell_holy_wordfortitude")
  wowkemonPanel.StaminaUpgrade.texture:SetAllPoints()
  end

  wowkemonPanel.SetPvpWowkemon:SetScript("OnClick",function() selectedPVPWowkemon = dataKey end)
  wowkemonPanel.StaminaUpgrade:SetScript("OnClick",
    function()
      if WowkemonPlayerData["Wowkedex"][dataKey][1] >= 50 then
        WowkemonPlayerData["Wowkedex"][dataKey]["Stats"]["Stamina"] = WowkemonPlayerData["Wowkedex"][dataKey]["Stats"]["Stamina"] + 1;
        WowkemonPlayerData["Wowkedex"][dataKey][1] = WowkemonPlayerData["Wowkedex"][dataKey][1] - 50;
        makeWowkemonDetailFrame(dataKey,inFrame,modelID,skills)
      end
    end)
  wowkemonPanel.StaminaUpgrade:SetScript("OnEnter",
    function()
      local finalString ="Upgrade Stamina\n|cff00ff00Stamina + 1\n"
    if WowkemonPlayerData["Wowkedex"][dataKey][1] >= 50 then
      finalString = finalString.."|cff0000ffLeft click to upgrade (50)|r"
    else
      finalString = finalString.."|cffff0000Not enough candy (50)|r"
    end
      WowkemonSkillToolTip.Text:SetText(finalString);
      WowkemonSkillToolTip:SetHeight(WowkemonSkillToolTip.Text:GetHeight() + 15)
      WowkemonSkillToolTip:SetWidth(170)
      WowkemonSkillToolTip.Text:SetJustifyH("LEFT")
      WowkemonSkillToolTip:Show()
    end)
  wowkemonPanel.StaminaUpgrade:SetScript("OnLeave",
    function()
      WowkemonSkillToolTip:Hide()
    end)
    wowkemonPanel.render3d:SetDisplayInfo(modelID)
  wowkemonPanel.render3d:SetCreature(modelID)
  wowkemonPanel.render3d:SetSize(wowkemonPanel:GetHeight()/2,wowkemonPanel:GetWidth()/2)
  wowkemonPanel.render3d:SetPoint("TOPRIGHT",wowkemonPanel,"TOPRIGHT")
  for e in pairs(skillPanels) do
    skillPanels[e]:Hide();
  end
  for e in pairs(skills) do
    if skillPanels[e] == nil then -- create a new panel if it doesnt exist
      local skill = CreateFrame("Button","skillBtn"..e,wowkemonPanel);
      skill:SetSize(40,40)
      skill.texture = skill:CreateTexture(nil,"BACKGROUND");
      skillPanels[e] = skill
    end
    skillPanels[e]:SetPoint("BOTTOMLEFT",wowkemonPanel,"BOTTOMLEFT",30+ 50*e-50,0);
    skillPanels[e]:SetBackdrop(HeaderBackdrop);
    skillPanels[e]:EnableMouse()
    skillPanels[e]:SetScript("OnClick",
      function()
        if WowkemonPlayerData["Wowkedex"][dataKey][1] >= 200 then
          WowkemonPlayerData["Wowkedex"][dataKey][1] = WowkemonPlayerData["Wowkedex"][dataKey][1] - 200;
          WowkemonPlayerData["Wowkedex"][dataKey][4][skills[e]] = WowkemonPlayerData["Wowkedex"][dataKey][4][skills[e]] + 1
          makeWowkemonDetailFrame(dataKey,inFrame,modelID,skills)
        else
          print("Not enough candy");
        end

      end)
    skillPanels[e]:SetScript("OnEnter",
      function ()
        WowkemonSkillToolTip.Text:SetText(WowkemonSkills[skills[e]][8])
        wowkemonFormatTooltip(WowkemonSkills[skills[e]][8],skills[e],dataKey)
        WowkemonSkillToolTip:SetHeight(WowkemonSkillToolTip.Text:GetHeight() + 15)
          WowkemonSkillToolTip:SetWidth(WowkemonSkillToolTip.Text:GetWidth() + 15)
        WowkemonSkillToolTip:Show()
      end)
    skillPanels[e]:SetScript("OnLeave",
      function ()
        WowkemonSkillToolTip:Hide()
      end)
    skillPanels[e].texture:SetTexture(WowkemonSkills[skills[e]][7])
    skillPanels[e].texture:SetAllPoints()
    skillPanels[e]:Show()
--    skillPanels[e] -- update the panel content
    end
--wowkemonPanel.textContent:SetPoint("CENTER",wowkedexPanel,"CENTER")
--wowkemonPanel.textContent:SetPoint("CENTER")
--WowkemonPlayerData["Wowkedex"][dataKey]
end
function wowkemonFormatTooltip(skillText,skillName,Wowkemon)
local prefix = {"<dam>","<rank>","<School>","<AP>"}
local formatString = "|cff00aa00"..skillText
for p in pairs(prefix) do
local firstind,lastind = string.find(skillText,prefix[p]);
  if firstind ~= nil and WowkemonPlayerData["Wowkedex"][Wowkemon][4] ~= nil then
    if prefix[p] == "<rank>" then
      formatString =  string.gsub(formatString,"<rank>","|cffffffffrank: "..tostring(WowkemonPlayerData["Wowkedex"][Wowkemon][4][skillName]).."|cff00ff00")--..tostring(WowkemonPlayerData["Wowkedex"][Wowkemon][4][skillName]))
    elseif prefix[p] == "<dam>" then
        formatString =  formatString:gsub(prefix[p],math.max((WowkemonPlayerData["Wowkedex"][Wowkemon][4][skillName] * WowkemonSkills[skillName][3]) * WowkemonSkills[skillName][2]),WowkemonSkills[skillName][3])
    elseif prefix[p] =="<School>" then
      formatString =  formatString:gsub(prefix[p],WowkemonAttackSchools[string.upper(WowkemonSkills[skillName][1])]..""..WowkemonSkills[skillName][1].."|cff00ff00")
    end
  end
end


formatString = skillName.."\nAP: "..WowkemonSkills[skillName][4].."\n"..formatString
if WowkemonPlayerData["Wowkedex"][Wowkemon][1] >= 200 then
formatString = formatString.."\n|cff0000ffLeft click to upgrade (200)|r"
else
formatString = formatString.."\n|cffff0000Not enough candy to upgrade (200)|r"
end
WowkemonSkillToolTip.Text:SetText(formatString)
WowkemonSkillToolTip.Text:SetJustifyH("LEFT");
end

function addToWowkedexList(wowkemon)
  local wowkemonTexturePath
  local wowkemonModelID = 1
  local wowkemonModelCamOffset = {0,0,0}
  local isRare = false;
  local index
  local skills
  for r,i in pairs(wowkemonUniqueSpawnLocs) do
     for p in pairs(i) do
    if i[p][1] == wowkemon[1] then
      wowkemonTexturePath = i[p][2];
      wowkemonModelID = i[p][6] or 5868;
      wowkemonModelCamOffset = i[p][7] or {0,0,0};
      index = r
      skills = i[p][4]
      isRare = true;
    --  print("Rare wowkemon skills:"..i[p][4])
      break
      end
    end
    end
    if isRare ~= true then
    for e in pairs(Wowkemons) do
      if Wowkemons[e][1] == wowkemon[1] then
        wowkemonTexturePath = Wowkemons[e][2]
        wowkemonModelID = Wowkemons[e][6] or 728
        wowkemonModelCamOffset = Wowkemons[e][7] or {0,0,0}
        skills = Wowkemons[e][4]
        break
      end
    end
    end
    if row == 3 then
      column = column + 1
      row = 0
    end
      local frame = CreateFrame("Frame","wowkedexEntry"..wowkemon[1],frameHolder.scrollchild)
      frame:SetPoint("TOPLEFT",frameHolder.scrollchild,"TOPLEFT",(row*spaceR)+ offsetX,(column*spaceC)+offsetY)
      frame:SetSize(80,80)
      frame:SetBackdrop(HeaderBackdrop)
      local btn = CreateFrame("Button","wowkedexBtn"..wowkemon[1],frame)
      frame.text = frame:CreateFontString(nil,"OVERLAY","GameFontNormal")
      frame.text:SetText(wowkemon[1])
      frame.text:SetPoint("TOP",frame,"TOP",0,10)
      frame.model = CreateFrame("DressUpModel","wowkemonModelFrame",frame);
      frame.model:SetSize(80,80)--(172,300)
      frame.model:SetModelScale(0.25)
      frame.model:SetDisplayInfo(wowkemonModelID)
      frame.model:SetCreature(wowkemonModelID)
      frame.model:SetPosition(wowkemonModelCamOffset[1],wowkemonModelCamOffset[2],wowkemonModelCamOffset[3])
      frame.model:SetAllPoints()
      btn:SetSize(frame:GetSize())
      btn:SetPoint("CENTER","wowkedexEntry"..wowkemon[1],"CENTER")
      btn:SetScript("OnClick", function() makeWowkemonDetailFrame(wowkemon[1],frameHolder,wowkemonModelID,skills) end)
      row = row + 1;
      table.insert(wowkedexFrames,wowkemon[1]);

    frameHolder.scrollchild:SetSize(frameHolder.scrollframe:GetWidth(), ( frameHolder.scrollframe:GetHeight() * math.max((column/2  ),1) ) )
end
